﻿// Author: Erucy
// Pub Date: 2012/4/27
// My Blog: http://erucy.cnblogs.com
// My Sina Weibo: @Erucy

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.SharePoint.Taxonomy;

namespace Erucy.Utilities
{
    public static class TaxonomyExtension
    {
        static List<Term> GetTermsByOrderInternal(TermCollection terms, string customOrder)
        {
            List<Term> result = new List<Term>(terms.Count);
            Dictionary<string, Term> idMap = new Dictionary<string, Term>();
            Dictionary<string, Term> nameMap = new Dictionary<string, Term>();
            Dictionary<string, string> idNameMap = new Dictionary<string, string>();
            foreach (Term term in terms)
            {
                nameMap[term.Name] = term;
                idMap[term.Id.ToString()] = term;
                idNameMap[term.Id.ToString()] = term.Name;
            }

            // Custom Order
            if (!string.IsNullOrEmpty(customOrder))
            {
                string[] termIds = customOrder.Split(':');
                foreach (string termId in termIds)
                {
                    if (idMap.ContainsKey(termId))
                    {
                        result.Add(idMap[termId]);
                        idNameMap.Remove(termId);
                    }
                }
            }

            // Others
            List<string> otherNames = new List<string>(idNameMap.Values);
            otherNames.Sort();
            foreach (string termName in otherNames)
                result.Add(nameMap[termName]);

            return result;
        }

        public static IEnumerable<Term> GetTermsByOrder(this TermSet termSet)
        {
            return GetTermsByOrderInternal(termSet.Terms, termSet.CustomSortOrder);
        }

        public static IEnumerable<Term> GetTermsByOrder(this Term term)
        {
            return GetTermsByOrderInternal(term.Terms, term.CustomSortOrder);
        }
    }
}
